--Lens Flare #2 effect filter v1.1 by khaver

obs = obslua

SETTING_HAIR = 'hair'
SETTING_CENTERX = 'centerx'
SETTING_CENTERY = 'centery'
SETTING_AMOUNT = 'amount'
SETTING_COMPLEX = 'complex'
SETTING_ZOOM = 'zoom'
SETTING_SCATTER = 'scatter'
SETTING_AFFECT = 'affect'
SETTING_THRESH = 'thresh'
SETTING_DIST = 'dist'

TEXT_HAIR = 'Show Target'
TEXT_CENTERX = 'Center X'
TEXT_CENTERY = 'Center Y'
TEXT_AMOUNT = 'Intensity'
TEXT_COMPLEX = 'Lens Adjustment'
TEXT_ZOOM = 'Flare Size'
TEXT_SCATTER = 'Light Scatter'
TEXT_AFFECT = 'Use Image Intensity'
TEXT_THRESH = 'Threshold'
TEXT_DIST = 'Flare Distance'

-- Returns the description displayed in the Scripts window
function script_description()
  return [[Lens Flare #2 by khaver]]
end

function script_load(settings)
  obs.obs_register_source(source_info)
end

source_info = {}
source_info.id = 'filter-lensflare2'
source_info.type = obs.OBS_SOURCE_TYPE_FILTER
source_info.output_flags = obs.OBS_SOURCE_VIDEO

source_info.get_name = function()
    return "Lens Flare #2"
end

source_info.create = function(settings, source)

    local filter = {}
    filter.source = source
	filter.width = 1
	filter.height = 1

    obs.obs_enter_graphics()
    --local effect_path = script_path() .. 'filter-lensflare2/filter-lensflare2.effect'
    --filter.effect = obs.gs_effect_create_from_file(effect_path, nil)
    filter.effect = obs.gs_effect_create(shader, nil, nil)
    obs.obs_leave_graphics()

    if filter.effect == nil then
        source_info.destroy(filter)
        return nil
    end

    filter.params = {}
        filter.params.hair = obs.gs_effect_get_param_by_name(filter.effect, 'hair')
        filter.params.centerx = obs.gs_effect_get_param_by_name(filter.effect, 'centerx')
        filter.params.centery = obs.gs_effect_get_param_by_name(filter.effect, 'centery')
        filter.params.amount = obs.gs_effect_get_param_by_name(filter.effect, 'amount')
        filter.params.complex = obs.gs_effect_get_param_by_name(filter.effect, 'complex')
        filter.params.zoom = obs.gs_effect_get_param_by_name(filter.effect, 'zoom')
        filter.params.scatter = obs.gs_effect_get_param_by_name(filter.effect, 'scatter')
        filter.params.affect = obs.gs_effect_get_param_by_name(filter.effect, 'affect')
        filter.params.thresh = obs.gs_effect_get_param_by_name(filter.effect, 'thresh')
        filter.params.dist = obs.gs_effect_get_param_by_name(filter.effect, 'dist')
        filter.params.width = obs.gs_effect_get_param_by_name(filter.effect, 'width')
        filter.params.height = obs.gs_effect_get_param_by_name(filter.effect, 'height')
		--filter.params.time = obs.gs_effect_get_param_by_name(filter.effect, 'time')

    source_info.update(filter, settings)
    return filter
end

source_info.destroy = function(filter)
    if filter.effect ~= nil then
        obs.obs_enter_graphics()
        obs.gs_effect_destroy(filter.effect)
		filter.effect = nil
        obs.obs_leave_graphics()
    end
end

source_info.get_width = function(filter)
    return filter.width
end

source_info.get_height = function(filter)
    return filter.height
end

source_info.get_properties = function(settings)
    props = obs.obs_properties_create()

    obs.obs_properties_add_bool(props, SETTING_HAIR, TEXT_HAIR)
    obs.obs_properties_add_float_slider(props, SETTING_CENTERX, TEXT_CENTERX, -1.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_CENTERY, TEXT_CENTERY, -1.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_AMOUNT, TEXT_AMOUNT, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_COMPLEX, TEXT_COMPLEX, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_DIST, TEXT_DIST, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_ZOOM, TEXT_ZOOM, 0.0, 1.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_SCATTER, TEXT_SCATTER, 0.0, 1.0, 0.001)
    obs.obs_properties_add_bool(props, SETTING_AFFECT, TEXT_AFFECT)
    obs.obs_properties_add_float_slider(props, SETTING_THRESH, TEXT_THRESH, 0.0, 1.0, 0.001)

    return props
end

source_info.get_defaults = function(settings)
    obs.obs_data_set_default_double(settings, SETTING_CENTERX, -0.375)
    obs.obs_data_set_default_double(settings, SETTING_CENTERY, 0.25)
    obs.obs_data_set_default_double(settings, SETTING_AMOUNT, 2.0)
    obs.obs_data_set_default_double(settings, SETTING_COMPLEX, 1.0)
    obs.obs_data_set_default_double(settings, SETTING_ZOOM, 1.0)
    obs.obs_data_set_default_double(settings, SETTING_SCATTER, 1.0)
    obs.obs_data_set_default_bool(settings, SETTING_AFFECT, false)
    obs.obs_data_set_default_double(settings, SETTING_THRESH, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_DIST, 1.0)
    obs.obs_data_set_default_bool(settings, SETTING_HAIR, false)
end

source_info.update = function(filter, settings)
    filter.centerx = obs.obs_data_get_double(settings, SETTING_CENTERX)
    filter.centery = obs.obs_data_get_double(settings, SETTING_CENTERY)
    filter.amount = obs.obs_data_get_double(settings, SETTING_AMOUNT)
    filter.complex = obs.obs_data_get_double(settings, SETTING_COMPLEX)
    filter.zoom = obs.obs_data_get_double(settings, SETTING_ZOOM)
    filter.scatter = obs.obs_data_get_double(settings, SETTING_SCATTER)
    filter.affect = obs.obs_data_get_bool(settings, SETTING_AFFECT)
    filter.thresh = obs.obs_data_get_double(settings, SETTING_THRESH)
    filter.dist = obs.obs_data_get_double(settings, SETTING_DIST)
    filter.hair = obs.obs_data_get_bool(settings, SETTING_HAIR)

end

source_info.video_render = function(filter)

  if not obs.obs_source_process_filter_begin(filter.source, obs.GS_RGBA, obs.OBS_NO_DIRECT_RENDERING) then return end

  local parent = obs.obs_filter_get_parent(filter.source)
  filter.width = obs.obs_source_get_base_width(parent)
  filter.height = obs.obs_source_get_base_height(parent)
  --filter.time = os.clock()


    obs.gs_effect_set_bool(filter.params.hair, filter.hair)
    obs.gs_effect_set_float(filter.params.centerx, filter.centerx)
    obs.gs_effect_set_float(filter.params.centery, filter.centery)
    obs.gs_effect_set_float(filter.params.amount, filter.amount)
    obs.gs_effect_set_float(filter.params.complex, filter.complex)
    obs.gs_effect_set_float(filter.params.zoom, filter.zoom)
    obs.gs_effect_set_float(filter.params.scatter, filter.scatter)
    obs.gs_effect_set_bool(filter.params.affect, filter.affect)
    obs.gs_effect_set_float(filter.params.thresh, filter.thresh)
    obs.gs_effect_set_float(filter.params.dist, filter.dist)
	obs.gs_effect_set_int(filter.params.width, filter.width)
	obs.gs_effect_set_int(filter.params.height, filter.height)
    --obs.gs_effect_set_float(filter.params.time, filter.time)

    obs.obs_source_process_filter_end(filter.source, filter.effect, filter.width, filter.height)
end

shader = [[
//Lens Flare #2 effect filter by khaver


uniform float4x4 ViewProj;
uniform texture2d image;

uniform bool hair;
uniform float centerx;
uniform float centery;
uniform float amount;
uniform float complex;
uniform float zoom;
uniform float scatter;
uniform bool affect;
uniform float thresh;
uniform float dist;
uniform int width;
uniform int height;
//uniform float time;

sampler_state textureSampler {
    Filter    = Linear;
    AddressU  = Clamp;
    AddressV  = Clamp;
};

struct VertDataIn {
    float4 pos : POSITION;
    float2 uv  : TEXCOORD0;
};

struct VertDataOut {
    float4 pos : POSITION;
    float2 uv  : TEXCOORD0;
};

VertDataOut VSDefault(VertDataIn v_in)
{
    VertDataOut vert_out;
    vert_out.pos = mul(float4(v_in.pos.xyz, 1.0), ViewProj);
    vert_out.uv  = v_in.uv;
    return vert_out;
}

float vary()
{
   float pixX = 1.0 / float(width);
   float pixY = 1.0 / float(height);

   float2 iMouse = float2(centerx + 0.5, 1.0 - (centery + 0.5));

   float4 col = image.Sample(textureSampler, iMouse);
   col += image.Sample(textureSampler, iMouse - float2(pixX, pixY));
   col += image.Sample(textureSampler, float2(iMouse.x, iMouse.y - pixY));
   col += image.Sample(textureSampler, iMouse + float2(pixX, -pixY));

   col += image.Sample(textureSampler, float2(iMouse.x - pixX, iMouse.y));
   col += image.Sample(textureSampler, float2(iMouse.x + pixX, iMouse.y));

   col += image.Sample(textureSampler, iMouse - float2(pixX, -pixY));
   col += image.Sample(textureSampler, float2(iMouse.x, iMouse.y + pixY));
   col += image.Sample(textureSampler, iMouse + float2(pixX, pixY));

   col /= 9.0;

   return dot(col.rgb, float3(0.33333, 0.33334, 0.33333));
}

float3 lensflare(float2 uv, float2 pos)
{
   float v = vary();

   if (v < thresh) v = 0.0;

   if (!affect) v = 1.0;

   pos *= dist;

   float intensity = amount;
   float _scatter = (1.0 - scatter) * 0.85;

   float2 uvd = uv * (length(uv) * complex);

   float f1 = max(0.01 - pow(length(uv + 1.2 * pos), 1.9 * zoom * v), 0.0) * 7.0;
   float f2 = max(1.0 / (1.0 + 32.0 * pow(length(uvd + 0.8 * pos), 2.0 * zoom * v)), 0.0) * 0.1;
   float f22 = max(1.0 / (1.0 + 32.0 * pow(length(uvd + 0.85 * pos), 2.0 * zoom * v)), 0.0) * 0.08;
   float f23 = max(1.0 / (1.0 + 32.0 * pow(length(uvd + 0.9 * pos), 2.0 * zoom * v)), 0.0) * 0.06;

   float2 uvx = lerp(uv, uvd, -0.5);

   float f4 = max(0.01 - pow(length (uvx + 0.4 * pos), 2.4 * zoom * v), 0.0) * 6.0;
   float f42 = max(0.01 - pow(length(uvx + 0.45 * pos), 2.4 * zoom * v), 0.0) * 5.0;
   float f43 = max(0.01 - pow(length(uvx + 0.5 * pos), 2.4 * zoom * v), 0.0) * 3.0;

   uvx = lerp(uv, uvd, -0.4);

   float f5 = max(0.01 - pow(length(uvx + 0.2 * pos), 5.5 * zoom * v), 0.0) * 2.0;
   float f52 = max(0.01 - pow(length(uvx + 0.4 * pos), 5.5 * zoom * v), 0.0) * 2.0;
   float f53 = max(0.01 - pow(length(uvx + 0.6 * pos), 5.5 * zoom * v), 0.0) * 2.0;

   uvx = lerp(uv, uvd, -0.5);

   float f6 = max(0.01 - pow(length(uvx - 0.3 * pos), 1.6 * zoom * v), 0.0) * 6.0;
   float f62 = max(0.01 - pow(length(uvx - 0.325 * pos), 1.6 * zoom * v), 0.0) * 3.0;
   float f63 = max(0.01 - pow(length(uvx - 0.35 * pos), 1.6 * zoom * v), 0.0) * 5.0;

   float3 c = 0.0.xxx;

   c.r += f2 + f4 + f5 + f6;
   c.g += f22 + f42 + f52 + f62;
   c.b += f23 + f43 + f53 + f63;

   return ((c * 1.3) - (length(uvd) * _scatter).xxx) * intensity;
}

float3 cc (float3 color, float factor, float factor2)
{
   float w = color.r +color.g + color.b;

   return lerp(color, w.xxx * factor, w * factor2);
}

float4 PassThrough(VertDataOut v_in) : TARGET
{
   float4 fragColor;
   float3 Green = float3(0.0, 1.0, 0.0);
   float2 fragCoord = v_in.uv;
   float _OutputAspectRatio = float(width) / float(height);
   float pixX = (1.0 / float(width)) * 2.0;
   float pixY = (1.0 / float(height)) * 2.0;

   float3 orig = image.Sample(textureSampler, fragCoord).rgb;

   float2 uv = fragCoord - 0.5.xx;
   float2 mouse = float2((centerx) * _OutputAspectRatio, centery * -1.0);

   uv.x *= _OutputAspectRatio;

   float3 color = float3(1.5, 1.2, 1.2) * lensflare(uv, mouse);

   color = saturate(cc(color, 0.5, 0.1));
   mouse.x /= _OutputAspectRatio;
   mouse += 0.5;

   fragColor = float4(color, 1.0);
   if (hair) {
		if (mouse.x >= (fragCoord.x - pixX) && mouse.x <= (fragCoord.x + pixX)) orig = Green;
		if (mouse.y >= (fragCoord.y - pixY) && mouse.y <= (fragCoord.y + pixY)) orig = Green;
   }

   return float4(saturate(orig + fragColor.rgb), 1.0);

}

technique Draw
{
    pass
    {
        vertex_shader = VSDefault(v_in);
        pixel_shader  = PassThrough(v_in);
    }
}
]]
